<?php

if(!empty($_FILES['backup'])){
	$file = $_FILES['backup'];
	$tmp_name = $file['tmp_name'];
	$backupPath = "backup/backup-" . time() . ".spx";
	move_uploaded_file($tmp_name, $backupPath);
}else{
	die("<h1>فایلی برای بکاپ ارسال نشد !</h1>");
}

$mysqli = new mysqli("localhost", "root", "", "wpx");
if ($mysqli->connect_error) {
    die("MYSQL ISSUE : " . $mysqli->connect_error);
}

$mysqli->set_charset("utf8");
$stmt = $mysqli->stmt_init();

$filepath = $backupPath;
$backupContent = file_get_contents($filepath);
$backupContent = explode("\n",$backupContent);
$backupContent = array_filter($backupContent, 'strlen');

$tableSeperator = "###";
$createTableSeperator = "%%%";

$table = "";
$createTable = "";

foreach($backupContent as $cnt){
	
	if(startsWith($cnt , $tableSeperator)){
		$table = $cnt;
		$table = getPureContent($table, $tableSeperator);
	}else if(startsWith($cnt , $createTableSeperator)){
		$createTable = $cnt;
		$createTable = getPureContent($createTable, $createTableSeperator);
		setDataRaw("DROP TABLE IF EXISTS `{$table}`");
		setDataRaw("SET SQL_MODE='ALLOW_INVALID_DATES'");
		setDataRaw($createTable);
	}else{
		$dataList = json_decode($cnt, true);
		foreach($dataList as $row){
			$values = (array) array_values($row);
			$valuePlaceholder = str_repeat("?,",count($values));
			$valuePlaceholder = substr($valuePlaceholder, 0, strlen($valuePlaceholder)-1);
			$query = "INSERT INTO `{$table}` VALUES ({$valuePlaceholder})";
			setData($query, $values);
		}
	}

}


function setData($uquery , $values){
	global $mysqli;
	global $stmt;
	
	$query = $uquery;
	$stmt->prepare($query);
	$type = str_repeat("s",count($values));
	$stmt->bind_param($type, ...$values);
	$inserted_id=0;
	if ($stmt->execute()) {
		$inserted_id = $stmt->affected_rows ? $stmt->insert_id : 0;
	}
	return $inserted_id;
}

function setDataRaw($uquery){
	global $mysqli;
	global $stmt;

	$query = $uquery;
	$stmt->prepare($query);
	$inserted_id=0;
	if ($stmt->execute()) {
		$inserted_id = $stmt->affected_rows ? $stmt->insert_id : 0;
	}

}

function startsWith ($string, $startString)
{
    $len = strlen($startString);
    return (substr($string, 0, $len) === $startString);
}

function endsWith($string, $endString)
{
    $len = strlen($endString);
    if ($len == 0) {
        return true;
    }
    return (substr($string, -$len) === $endString);
}

function getPureContent($string, $seperator){
	$seperatorLength = strlen($seperator);
	$finalString = substr($string, $seperatorLength);
	$finalString = substr($finalString, 0,-$seperatorLength);
	return $finalString;
}


$stmt->close();
$mysqli->close();

header("Location: {$_SERVER['PHP_SELF']}?msg=بکاپ+با+موفقیت+وارد+دیتابیس+شد");

?>